import es
from es import server_var
import playerlib, gamethread
import os, random, datetime
from sqlite3 import dbapi2 as sqlite
from configobj import ConfigObj

class SQlite3Con(object):
    def __init__(self, path):
		self.path = path
		self.con = sqlite.connect(path)
		self.cur = self.con.cursor()
    def utfcode(self,value):
        if type(value).__name__ == 'unicode':
            return value.encode('utf-8')
        return value 
    def convertQuery(self,result):
        newresult = list()
        for row in result:
            newrow = [self.utfcode(item) for item in row]
            newresult.append(newrow)
        return newresult
    def execute(self,sql):
        self.cur.execute(self.utfcode(sql))
        self.con.commit()
    def xexecute(self,sql):
        self.cur.execute(sql)
        self.con.commit()
    def freequery(self, sql):
        self.cur.execute(sql)
    def query(self, sql):
        self.cur.execute(sql)
        return self.convertQuery(self.cur.fetchall())
    def xquery(self, sql):
        self.cur.execute(sql)
        return self.cur.fetchall()
	def rollback(self):
		self.con.rollback()
    def close(self):
        self.con.close()
		
class DownloadMngr:
	def __init__(self):
		self.data = []
	def reset(self):
		self.data = []
	def add(self, file):
		if not file:
			return False
		if not os.path.isfile(file):
			es.dbgmsg(0, "SCTF: Unable to found '%s'" % file)
			return False
		es.stringtable('downloadables', file)
		return True
	def addByFile(self, file):
		if not file:
			return 0
		if not os.path.isfile(file):
			es.dbgmsg(0, "SCTF: Unable to found '%s'" % file)
			return 0
		f = open(file)
		if not f:
			es.dbgmsg(0, "SCTF: Unable to read '%s'" % file)
			return 0
		lines = f.readlines()
		i = 0
		if lines:
			for line in lines:
				if len(line) < 12:
					continue
				line = line.strip()
				line_array = line.split(None, 1)
				line = line_array[0]
				if len(line) >= 12 and line[0:2] <> "//" and line[0:1] <> "#":
					if not line in self.data:
						self.data.append(line)
						es.stringtable('downloadables', line)
						#es.dbgmsg(0, "SCTF: Added Download: %s" % line)
			es.dbgmsg(0, "SCTF: Added '%i' Downloads" % i)
		f.close()
		return len(self.data)
	def reAdd(self):
		for file in self.data:
			es.stringtable('downloadables', file)
		es.dbgmsg(0, "SCTF: ReAdded '%i' Downloads" % len(self.data))
	def exists(self, file):
		return (file in self.data)
	def count(self):
		return len(self.data)
	def printAll(self):
		i = 0
		es.dbgmsg(0, " ")
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, "Current Downloads: (%i)" % len(self.data))
		es.dbgmsg(0, " ")
		for file in self.data:
			i += 1;
			es.dbgmsg(0, "%i: %s" % (i, file))
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, " ")
		
class Admins:
	data = []
	def __init__(self, defFile):
		self.file = defFile
		global data
		data = []
	def reset(self, defFile = None):
		global data
		data = []
		
		if defFile is not None:
			self.file = defFile
	def load(self):
		if not self.file:
			return 0
		if not os.path.isfile(self.file):
			es.dbgmsg(0, "SCTF: Unable to found '%s'" % self.file)
			return 0
		f = open(self.file)
		if not f:
			es.dbgmsg(0, "SCTF: Unable to read '%s'" % self.file)
			return 0
		lines = f.readlines()
		if lines:
			global data
			data = []
			for steamid in lines:
				if len(steamid) < 11:
					continue
				steamid = steamid.upper()
				steamid = steamid.strip()
				steamid_array = steamid.split(None, 1)
				steamid = steamid_array[0]
				if len(steamid) >= 11 and steamid[0:2] <> "//" and steamid[0:1] <> "#" and steamid[0:6] == "STEAM_":
					if not steamid in data:
						data.append(steamid)
						es.dbgmsg(0, "SCTF: Added Admin: %s" % steamid)
		f.close()
		return len(data)
	def save(topText = None, toFile = None):
		filetoSave = self.file
		if toFile is not None:
			filetoSave = toFile
			
		f = open(filetoSave, 'w')
		if not f:
			return False
			
		toWrite = ""
			
		if topText is not None:
			toWrite = topText
			
		for steamid in data:
			toWrite = "%s\n%s" % (toWrite, steamid)
			
		f.write(toWrite)
		f.close()
			
		es.dbgmsg(0, "SCTF: Admin file sucessfully saved to '%s'" % filetoSave)
		return True
	def getIndex(self, steamid):
		if not steamid:
			return -1
		return data.index(steamid.upper())
	def isAdmin(self, steamid):
		if not steamid:
			return False
			
		#steamid = steamid.upper()
		return (steamid.upper() in data)
	def count(self):
		return len(data)
	def addAdmin(self, steamid):
		if not steamid:
			return False
		global data
		steamid = steamid.upper()
		steamid = steamid.strip()
		if len(steamid) >= 11 and steamid[0:6] == "STEAM_":
			if not steamid in data:
				data.append(steamid)
				es.dbgmsg(0, "SCTF: Added Admin: %s" % steamid)
			return True
		
		return False
	def delAdmin(self, steamid):
		index = getIndex(steamid)
		if index == -1:
			return False
		global data
		data.remove(index)
		es.dbgmsg(0, "SCTF: Removed Admin: %s" % steamid)
		return True
	def printAll(self):
		i = 0
		es.dbgmsg(0, " ")
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, "Current Admins: (%i)" % len(data))
		es.dbgmsg(0, " ")
		for steamid in data:
			i += 1;
			es.dbgmsg(0, "%i: %s" % (i, steamid))
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, " ")
		
_sctf_classes_opt = {2:{},3:{}}
class ClassMngr:
	def __init__(self):
		self.menucount = {2:0,3:0}
		self.menupages = {2:1,3:1}
	def reset(self):
		global _sctf_classes_opt
		_sctf_classes_opt.clear()
		_sctf_classes_opt = {2:{},3:{}}
		self.menucount = {2:0,3:0}
		self.menupages = {2:1,3:1}
	def addClass(self, name, desc, health, speed, weapons, team = "0", model = None):
		global _sctf_classes_opt
		
		iteam = 0
		if team[0:1] == "2" or team[0:1] == "t":
			iteam = 2
		elif team[0:1] == "3" or team[0:1] == "c":
			iteam = 3
			
		classMaker = {}
		classMaker['team'] = iteam
		classMaker['name'] = name
		classMaker['desc'] = desc
		classMaker['model'] = None
		if model:
			model = model.replace("/", "\\")
			if not model.startswith("models\\"):
				model = "models\\" + model
			if not model.endswith(".mdl"):
				model += ".mdl"
				
			if os.path.isfile(_sctf_opt['game_options']['game_path']+"\\"+model):
				classMaker['model'] = model
			
		classMaker['health'] = int(health)
		classMaker['speed'] = float(speed)
		classMaker['weaponsStr'] = weapons
		classMaker['weapons'] = {}
		weapons = weapons.strip()
		weapon_dict = weapons.split(",")
		windex = 0
		for item in weapon_dict:
			ammoSepIndex = item.find(":")
			classMaker['weapons'][windex] = {}
			if ammoSepIndex == -1:
				classMaker['weapons'][windex]['ammo'] = -1
				classMaker['weapons'][windex]['name'] = item
			else:
				ammoSepIndex += 1
				classMaker['weapons'][windex]['ammo'] = int(item[ammoSepIndex:])
				classMaker['weapons'][windex]['name'] = item[0:ammoSepIndex-1]
				
			if classMaker['weapons'][windex]['name'][0:5] != "item_":
				if classMaker['weapons'][windex]['name'][0:7] != "weapon_":
					classMaker['weapons'][windex]['name'] = "weapon_" + classMaker['weapons'][windex]['name']
			else:
				classMaker['weapons'][windex]['ammo'] = -1
			windex += 1
		"""
		index = len(_sctf_classes_opt)
		_sctf_classes_opt[index] = {}
		_sctf_classes_opt[index]['team'] = iteam
		_sctf_classes_opt[index]['name'] = name
		_sctf_classes_opt[index]['desc'] = desc
		_sctf_classes_opt[index]['model'] = None
		if model:
			model = model.replace("/", "\\")
			if not model.startswith("models\\"):
				model = "models\\" + model
			if not model.endswith(".mdl"):
				model += ".mdl"
				
			if os.path.isfile(_sctf_opt['game_options']['game_path']+"\\"+model):
				_sctf_classes_opt[index]['model'] = model
			
		_sctf_classes_opt[index]['health'] = int(health)
		_sctf_classes_opt[index]['speed'] = float(speed)
		_sctf_classes_opt[index]['weaponsStr'] = weapons
		_sctf_classes_opt[index]['weapons'] = {}
		weapons = weapons.strip()
		weapon_dict = weapons.split(",")
		windex = 0
		for item in weapon_dict:
			ammoSepIndex = item.find(":")
			_sctf_classes_opt[index]['weapons'][windex] = {}
			if ammoSepIndex == -1:
				_sctf_classes_opt[index]['weapons'][windex]['ammo'] = -1
				_sctf_classes_opt[index]['weapons'][windex]['name'] = item
			else:
				ammoSepIndex += 1
				_sctf_classes_opt[index]['weapons'][windex]['ammo'] = int(item[ammoSepIndex:])
				_sctf_classes_opt[index]['weapons'][windex]['name'] = item[0:ammoSepIndex-1]
				
			if _sctf_classes_opt[index]['weapons'][windex]['name'][0:5] != "item_":
				if _sctf_classes_opt[index]['weapons'][windex]['name'][0:7] != "weapon_":
					_sctf_classes_opt[index]['weapons'][windex]['name'] = "weapon_" + _sctf_classes_opt[index]['weapons'][windex]['name']
			else:
				_sctf_classes_opt[index]['weapons'][windex]['ammo'] = -1
			windex += 1
		"""
		if iteam == 0:
			_sctf_classes_opt[2][len(_sctf_classes_opt[2])] = classMaker
			_sctf_classes_opt[3][len(_sctf_classes_opt[3])] = classMaker
			self.menucount[2] += 1
			self.menucount[3] += 1
			if self.menucount[2] >= 8:
				self.menucount[2] = 1
				self.menupages[2] += 1
			if self.menucount[3] >= 8:
				self.menucount[3] = 1
				self.menupages[3] += 1
		else:
			_sctf_classes_opt[iteam][len(_sctf_classes_opt[iteam])] = classMaker
			self.menucount[iteam] += 1
			if self.menucount[iteam] >= 8:
				self.menucount[iteam] = 1
				self.menupages[iteam] += 1
		es.dbgmsg(0, "SCTF: Added Class: %s (%i HP) (%f Speed) to team '%i'\n[%s] (%s)\n" % (name, classMaker['health'], classMaker['speed'], iteam, desc, classMaker['weaponsStr']))
	def removeClass(self, name):
		return None # Not implemented
		global _sctf_classes_opt
		for index in _sctf_classes_opt:
			if _sctf_classes_opt[index]['name'] == name:
				del _sctf_classes_opt[index]
	def randomClass(self, team):
		classeslen = len(_sctf_classes_opt[team])
		if classeslen  <= 0:
			return -1
		return random.randint(0, classeslen)
	def applyClass2Player(self, userid, team, index):
		if not _sctf_classes_opt[team].has_key(index):
			return False
		if len(_sctf_classes_opt[team][index]['weapons']) <= 0:
			return False
		es.server.cmd("est_StripPlayer %s" % userid)
		for windex in _sctf_classes_opt[team][index]['weapons']:
			es.server.cmd("es_xgive %s %s" % (userid, _sctf_classes_opt[team][index]['weapons'][windex]['name']))
			if _sctf_classes_opt[team][index]['weapons'][windex]['ammo'] >= 0:
				es.server.queuecmd("est_SetAmmo %s %s %i" % (userid, _sctf_classes_opt[team][index]['weapons'][windex]['name'], _sctf_classes_opt[team][index]['weapons'][windex]['ammo']))
		es.setplayerprop(userid, "CBasePlayer.m_iHealth", _sctf_classes_opt[team][index]['health'])
		es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", _sctf_classes_opt[team][index]['speed'])
		if _sctf_classes_opt[team][index]['model']:
			es.setplayerprop(userid, "CBaseEntity.m_nModelIndex", es.precachemodel(_sctf_classes_opt[team][index]['model']))
			playerlib.getPlayer(userid).set('color', ['255', '255', '255', '255'])
	def indexByName(self, team, name):
		for index in _sctf_classes_opt:
			if _sctf_classes_opt[team][index]['name'] == name:
				return index
	def getMenuPages(self, team):
		return self.menupages[team]
	def getMenuCount(self, team):
		return self.menucount[team]
	def isValidIndex(self, index, team):
		return _sctf_classes_opt[team].has_key(index)
	def copy(self):
		return _sctf_classes_opt
	def count(self, team):
		return len(_sctf_classes_opt[team])
	def printAll(self):
		es.dbgmsg(0, " ")
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, "Current Classes: (Team 2: %i | Team 3: %i)" % (len(_sctf_classes_opt[2]), len(_sctf_classes_opt[3])))
		es.dbgmsg(0, "TEAM 2:")
		for index in _sctf_classes_opt[2]:
			es.dbgmsg(0, "%i: %s (%i HP) (%s Speed)\n[%s] (%s)\nModel: %s\n" % (index+1, _sctf_classes_opt[2][index]['name'], _sctf_classes_opt[2][index]['health'], str(_sctf_classes_opt[2][index]['speed']), _sctf_classes_opt[2][index]['desc'], _sctf_classes_opt[2][index]['weaponsStr'], _sctf_classes_opt[2][index]['model']))
		es.dbgmsg(0, "\n------------------------------------\nTEAM 3:\n\n")
		for index in _sctf_classes_opt[3]:
			es.dbgmsg(0, "%i: %s (%i HP) (%s Speed)\n[%s] (%s)\nModel: %s\n" % (index+1, _sctf_classes_opt[3][index]['name'], _sctf_classes_opt[3][index]['health'], str(_sctf_classes_opt[3][index]['speed']), _sctf_classes_opt[3][index]['desc'], _sctf_classes_opt[3][index]['weaponsStr'], _sctf_classes_opt[3][index]['model']))
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, " ")
			
				
# all SCTF server variables are declared here for convenience 
sctf_version	  				= es.ServerVar("sctf_version",				"2.0BETA", "Current SCTF version.") 
sctf			  				= es.ServerVar("sctf",  					1, "Is SCTF enabled or disabled.") 

sctf_remove_inactive_players_after	= es.ServerVar("sctf_remove_inactive_players_after",  		35, "Remove inactive players from database after X days.") 
sctf_remove_time  				= es.ServerVar("sctf_remove_time",  		1, "Enable remove objectives and round never end.") 
sctf_remove_money  				= es.ServerVar("sctf_remove_money",  		1, "Remove any money from player.") 
sctf_clean_ground_time			= es.ServerVar("sctf_clean_ground_time",	30, "Time in seconds to clean the ground from bodys and items/weapons. Min: 1 | Max: 180") 
sctf_game_time  				= es.ServerVar("sctf_game_time",  			1, "Game time clock in Minutes. <5 = Disable.") 
sctf_score_limit				= es.ServerVar("sctf_score_limit",  		100, "When any team reach x points (Flags) game will end. 0 = Disable.") 
sctf_stats						= es.ServerVar("sctf_stats",				1, "Enable SCTF Stats.")
sctf_show_flag_status_hud		= es.ServerVar("sctf_show_flag_status_hud",	1, "Enable show a Hud with Flag information/status")
sctf_drop_flag_time				= es.ServerVar("sctf_drop_flag_time",		15, "Time to reset a droped flag. (<= 0 = Disable)")
sctf_sacrifice_for_score		= es.ServerVar("sctf_sacrifice_for_score",	0, "Player need sacrifice to score a flag")
sctf_use_classes				= es.ServerVar("sctf_use_classes",			1, "Allow player choose diferent classes with powers/weapons/items")

sctf_mapreload_settings			= es.ServerVar("sctf_mapreload_settings",	0, "Enable reload SCTF settings (sctf_server.cfg) every time map change.")
sctf_map_config					= es.ServerVar("sctf_map_config",			1, "Enable Load a diferent config for each map. See (addons/eventscripts/sctf/cfg/maps/)")

sctf_score_for_take_flag		= es.ServerVar("sctf_score_for_take_flag",	1, "Amount of Kills (+) a player will win when capture an flag.")
sctf_score_for_score_flag		= es.ServerVar("sctf_score_for_score_flag",	2, "Amount of Kills (+) a player will win when score an flag.")
sctf_score_for_return_flag		= es.ServerVar("sctf_score_for_return_flag",1, "Amount of Kills (+) a player will win when return the team flag.")
sctf_score_for_drop_flag		= es.ServerVar("sctf_score_for_drop_flag",	1, "Amount of Kills (-) a player will win when drop an flag.")

sctf_auto_spawn					= es.ServerVar("sctf_auto_spawn",			1, "Allow respawn players after dead.")
sctf_spawn_delay				= es.ServerVar("sctf_spawn_delay",			3, "Time to respawn player after dead.")
sctf_restrict_drop				= es.ServerVar("sctf_restrict_drop",		1, "Disallow players drop weapons.")

# Sounds
sctf_sound_blue_flag_taken		= es.ServerVar("sctf_sound_blue_flag_taken",  	"doors/vent_open2.wav", "Sound to listen at Blue Flag Taken (Only Team 3 [Blue] listen this sound).")  
sctf_sound_red_flag_taken		= es.ServerVar("sctf_sound_red_flag_taken",  	"doors/vent_open2.wav", "Sound to listen at Red Flag Taken (Only Team 2 [Red] listen this sound).")  

sctf_sound_blue_flag_capture	= es.ServerVar("sctf_sound_blue_flag_capture",  "items/battery_pickup.wav", "Sound to listen at Blue Flag Capture (Only Team 2 [Red] listen this sound).")  
sctf_sound_red_flag_capture		= es.ServerVar("sctf_sound_red_flag_capture",  	"items/battery_pickup.wav", "Sound to listen at Red Flag Capture (Only Team 3 [Blue] listen this sound).")  

sctf_sound_blue_flag_drop		= es.ServerVar("sctf_sound_blue_flag_drop",  	"buttons/blip1.wav", "Sound to listen at Blue Flag Drop (Only Team 3 [Blue] listen this sound).")  
sctf_sound_red_flag_drop		= es.ServerVar("sctf_sound_red_flag_drop",  	"buttons/blip1.wav", "Sound to listen at Red Flag Drop (Only Team 2 [Red] listen this sound).")  

sctf_sound_blue_flag_lost		= es.ServerVar("sctf_sound_blue_flag_lost",  	"ambient/alarms/warningbell1.wav", "Sound to listen at Blue Flag Lost (Only Team 2 [Red] listen this sound).")  
sctf_sound_red_flag_lost		= es.ServerVar("sctf_sound_red_flag_lost",  	"ambient/alarms/warningbell1.wav", "Sound to listen at Red Flag Lost (Only Team 3 [Blue] listen this sound).")  

sctf_sound_blue_flag_return		= es.ServerVar("sctf_sound_blue_flag_return",  	"ambient/explosions/explode_7.wav", "Sound to listen at Blue Flag Return (All players listen this sound).")  
sctf_sound_red_flag_return		= es.ServerVar("sctf_sound_red_flag_return",  	"ambient/explosions/explode_7.wav", "Sound to listen at Red Flag Return (All players listen this sound).")  

sctf_sound_blue_team_score		= es.ServerVar("sctf_sound_blue_team_score",  	"plats/elevbell1.wav", "Sound to listen when Blue Team Scores (All players listen this sound).")  
sctf_sound_red_team_score		= es.ServerVar("sctf_sound_red_team_score",  	"plats/elevbell1.wav", "Sound to listen when Red Team Scores (All players listen this sound).")  

sctf_sound_blue_team_wins		= es.ServerVar("sctf_sound_blue_team_wins",  	"music/HL1_song25_REMIX3.mp3", "Sound to listen when Blue Team Win the game (Only Team 3 [Blue] listen this sound).")
sctf_sound_red_team_wins		= es.ServerVar("sctf_sound_red_team_wins",  	"music/HL1_song25_REMIX3.mp3", "Sound to listen when Red Team Win the game (Only Team 2 [Red] listen this sound).")

sctf_sound_blue_team_lose		= es.ServerVar("sctf_sound_blue_team_lose",  	"music/HL1_song10.mp3", "Sound to listen when Blue Team Lost the game (Only Team 3 [Blue] listen this sound).")
sctf_sound_red_team_lose		= es.ServerVar("sctf_sound_red_team_lose",  	"music/HL1_song10.mp3", "Sound to listen when Red Team Lost the game (Only Team 2 [Red] listen this sound).")

sctf_sound_draw					= es.ServerVar("sctf_sound_draw",  				"music/HL1_song17.mp3", "Sound to listen when game end in Draw (All players listen this sound).")
# End Sounds

info = es.AddonInfo() 
info.name     	= "Sn4k3 Capture The Flag" 
info.basename 	= "SCTF"
info.version  	= str(sctf_version)
info.url      	= "http://addons.eventscripts.com/addons/view/SCTF" 
info.description = "Capture the flag mod"
info.author   	= "sn4k3"
#info.contact  	= "Tiago_caza@hotmail.com"
#info.tags	= "sctf,flag,ctf,control point"

"""
Flag Maker:
   X   +   X1
Z1 ||||||||||
   ||      ||
   ||||||||||
   ||  -   Z2
+  ||
   ||
   ||
   ||
Z  ||
   X
   
XYZ = Original Coords
X* Y* Z* = Math for Orginal Coords

All Flags Base:
Glow (XYZ)
Beam (XYZ TO XYZ1)    
Beam (XYZ1 TO X1YZ1)  
Beam (X1YZ1 TO X1YZ2)
Beam (X1YZ2 TO XYZ2)

All Captured Flags:
Beam (XYZ2 TO X1YZ1)
Beam (XYZ1 TO X1YZ2)

Ts Not Captured Flag:
Beam (XYZ2 TO X1YZ1)

CTs Not Captured Flag:
Beam (XYZ1 TO X1YZ2)
"""



_sctf_opt = {}
_sctf_opt['dev'] = {}
_sctf_opt['dev']['db_version'] = 1.0
_sctf_opt['game_options'] = {}
_sctf_opt['game_options']['path'] = es.getAddonPath("sctf") + "/"
_sctf_opt['game_options']['game_path'] = str(es.ServerVar('eventscripts_gamedir')) 
_sctf_opt['game_options']['config_path'] = _sctf_opt['game_options']['path'] + "cfg/"
_sctf_opt['game_options']['config_short_path'] = "addons/eventscripts/sctf/cfg/"
_sctf_opt['game_options']['data_path'] = _sctf_opt['game_options']['path'] + "data/"
_sctf_opt['game_options']['game_time'] = -99
_sctf_opt['game_options']['score_limit'] = -99
_sctf_opt['game_options']['clean_idle'] = 10.0
_sctf_opt['game_options']['round_end'] = False
_sctf_opt['game_options']['blue_score'] = 0
_sctf_opt['game_options']['red_score'] = 0
_sctf_opt['game_sounds'] = {
'blue_flag_taken' : str(sctf_sound_blue_flag_taken), 'red_flag_taken' : str(sctf_sound_red_flag_taken),
'blue_flag_capture' : str(sctf_sound_blue_flag_capture), 'red_flag_capture' : str(sctf_sound_red_flag_capture),
'blue_flag_drop' : str(sctf_sound_blue_flag_drop), 'red_flag_drop' : str(sctf_sound_red_flag_drop),
'blue_flag_lost' : str(sctf_sound_blue_flag_lost), 'red_flag_lost' : str(sctf_sound_red_flag_lost),
'blue_flag_return' : str(sctf_sound_blue_flag_return), 'red_flag_return' : str(sctf_sound_red_flag_return),
'blue_team_score' : str(sctf_sound_blue_team_score), 'red_team_score' : str(sctf_sound_red_team_score),
'blue_team_wins' : str(sctf_sound_blue_team_wins), 'red_team_wins' : str(sctf_sound_red_team_wins),
'blue_team_lose' : str(sctf_sound_blue_team_lose), 'red_team_lose' : str(sctf_sound_red_team_lose),
'draw' : sctf_sound_draw
}
_sctf_opt['dev_sounds'] = {
'menuselect' 	: "buttons/button14.wav", 		'menuexit' 		: "buttons/combine_button7.wav",
'menuback'		: "UI/buttonclickrelease.wav",	'menunext'		: "UI/buttonrollover.wav",
'restrict' 		: "buttons/button8.wav"
}
_sctf_opt['flag_maker'] = {}
_sctf_opt['flag_maker']['live_time'] = 1.1
_sctf_opt['flag_maker']['live'] = {
'z1' : 160, # + (z+z1)
'z2' : 40,  # -  (z1-z2)
'x1' : 65   # + (x+x1)
}
_sctf_opt['flag_maker']['drop'] = {
'z' : 63,   # - (z-z)
'z1' : 120,  # + (z+z1)
'z2' : 40,  # - (z1-z2)
'x1' : 65,  # + (x+x1)
}
# Keys: defcoord, currentcoord, color, status, team, timedrop, owner, x, y, z, dx, dy, dz
# status: 0 = UnCap | 1 = Cap | 2 = Drop
_sctf_opt['flags'] = {}

_sctf_players = {}
_sctf_mapflag = ConfigObj(_sctf_opt['game_options']['data_path'] + 'sctf_ctf_info.ini')
_sctf_stats = SQlite3Con(_sctf_opt['game_options']['data_path'] + "sctf_stats.db")
_sctf_admins = Admins(_sctf_opt['game_options']['config_path'] + "sctf_admins.txt")
_sctf_classes = ClassMngr()
"""
_sctf_classes.addClass("Cowboy", "Fast but pistols only", 150, 1.7, "knife,elite:200,hegrenade,flashbang")
_sctf_classes.addClass("Scout", "Good for rush enemy flag", 50, 2.0, "knife,p228:100,mp5navy:200,hegrenade:2")
_sctf_classes.addClass("Rifleman", "High precision rifles", 130, 1.1, "knife,deagle:50,ak47:200,hegrenade:2,flashbang,smokegrenade")
_sctf_classes.addClass("Silenced", "No Noisy guns", 110, 1.3, "knife,usp:200,tmp:200,flashbang:2")
_sctf_classes.addClass("Shotgunner", "Low distances effective", 130, 1.2, "knife,glock:200,m3:60,hegrenade:2,flashbang,smokegrenade")
_sctf_classes.addClass("Support", "Good for take care of our flag", 250, 0.8, "knife,deagle:100,m249:500,hegrenade:3,flashbang,smokegrenade:2")
_sctf_classes.addClass("Grenadier", "Blow up the enemys with explosives", 140, 1.0, "knife,deagle:200,hegrenade:20,flashbang:5,smokegrenade:5")
_sctf_classes.addClass("Ligth Sniper", "Clean the guys at high distances", 130, 1.0, "knife,fiveseven:100,scout:50,hegrenade,flashbang:2,smokegrenade:2")
_sctf_classes.addClass("Heavy Sniper", "Clean the guys at high distances", 170, 1.0, "knife,deagle:100,awp:50,hegrenade,flashbang:2,smokegrenade:2")
"""


def reset(isLoad = False):
	global _sctf_opt
	global _sctf_players
	sctf_version.set(info.version)
	sctf.set("1")
	
	es.stringtable('downloadables', 'models/mapmodels/flags.dx80.vtx')
	es.stringtable('downloadables', 'models/mapmodels/flags.dx90.vtx')
	es.stringtable('downloadables', 'models/mapmodels/flags.mdl')
	es.stringtable('downloadables', 'models/mapmodels/flags.sw.vtx')
	es.stringtable('downloadables', 'models/mapmodels/flags.vvd')
	#es.stringtable('downloadables', 'models/mapmodels/flags.xbox.vtx')
	es.stringtable('downloadables', 'models/mapmodels/flags2.dx80.vtx')
	es.stringtable('downloadables', 'models/mapmodels/flags2.dx90.vtx')
	es.stringtable('downloadables', 'models/mapmodels/flags2.mdl')
	es.stringtable('downloadables', 'models/mapmodels/flags2.sw.vtx')
	es.stringtable('downloadables', 'models/mapmodels/flags2.vvd')
	es.stringtable('downloadables', 'models/mapmodels/flags2.xbox.vtx')
	es.stringtable('downloadables', 'models/mapmodels/pole.dx80.vtx')
	es.stringtable('downloadables', 'models/mapmodels/pole.dx90.vtx')
	es.stringtable('downloadables', 'models/mapmodels/pole.mdl')
	es.stringtable('downloadables', 'models/mapmodels/pole.sw.vtx')
	es.stringtable('downloadables', 'models/mapmodels/pole.vvd')
	es.stringtable('downloadables', 'models/mapmodels/pole.xbox.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_blueflag.dx80.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_blueflag.dx90.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_blueflag.mdl')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_blueflag.sw.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_blueflag.vvd')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_blueflag.phy')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_blueflag.xbox.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_redflag.dx80.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_redflag.dx90.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_redflag.mdl')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_redflag.sw.vtx')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_redflag.vvd')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_redflag.phy')
	es.stringtable('downloadables', 'models/extras/sctf/info_speech_redflag.xbox.vtx')
	# Meterials
	es.stringtable('downloadables', 'materials/models/mapmodels/flags/axisflag.vmt')
	es.stringtable('downloadables', 'materials/models/mapmodels/flags/axisflag.vtf')
	es.stringtable('downloadables', 'materials/models/mapmodels/flags/neutralflag.vmt')
	es.stringtable('downloadables', 'materials/models/mapmodels/flags/neutralflag.vtf')
	es.stringtable('downloadables', 'materials/models/extras/sctf/speech_info_blueflag.vmt')
	es.stringtable('downloadables', 'materials/models/extras/sctf/speech_info_blueflag.vtf')
	es.stringtable('downloadables', 'materials/models/extras/sctf/speech_info_redflag.vmt')
	es.stringtable('downloadables', 'materials/models/extras/sctf/speech_info_redflag.vtf')
	
	DownloadMngr().addByFile(_sctf_opt['game_options']['config_path'] + "sctf_downloads.txt")
	
	if not os.path.isdir(_sctf_opt['game_options']['data_path']):
		os.mkdir(_sctf_opt['game_options']['data_path'])
	
	if not os.path.isfile(_sctf_opt['game_options']['data_path'] + 'sctf_ctf_info.ini'):
		_sctf_mapflag.write()
	
	if int(sctf_map_config) > 0:
		mapfile = "%smaps/%s.cfg" % (_sctf_opt['game_options']['config_path'], str(es.ServerVar('eventscripts_currentmap')))
		if os.path.isfile(mapfile):
			es.server.cmd("es_xmexec ..%s" % mapfile.replace(_sctf_opt['game_options']['game_path'], '', 1))
	_sctf_classes.reset()
	es.server.cmd("es_xmexec ../%ssctf_sounds.cfg;es_xmexec ../%ssctf_models.cfg" % (_sctf_opt['game_options']['config_short_path'], _sctf_opt['game_options']['config_short_path']))

	if int(sctf_remove_time) > 0:
		entlist = es.createentitylist()
		for index in entlist:
			if entlist[index]['classname'] == "func_hostage_rescue" or entlist[index]['classname'] == "func_bomb_target":
				es.server.queuecmd('es_xremove %s' % index)
	
	gamethread.cancelDelayed("clean_idle")
	gamethread.cancelDelayed("repeat1s")
	_sctf_players.clear()
	_sctf_players = {}
	_sctf_opt['game_options']['blue_score'] = 0
	_sctf_opt['game_options']['red_score'] = 0
	_sctf_opt['game_options']['game_time'] = -99
	_sctf_opt['game_options']['score_limit'] = -99
	if int(sctf_game_time) >= 5:
		_sctf_opt['game_options']['game_time'] = int(sctf_game_time)
	if int(sctf_score_limit) > 0:
		_sctf_opt['game_options']['score_limit'] = int(sctf_score_limit)
	
	# Sounds
	temp_sound_array = []
	for key in _sctf_opt['game_sounds']:
		if str(es.ServerVar("sctf_sound_" + key)) and len(str(es.ServerVar("sctf_sound_" + key))) > 3 and (str(es.ServerVar("sctf_sound_" + key)).endswith(".wav") or str(es.ServerVar("sctf_sound_" + key)).endswith(".mp3")):
			_sctf_opt['game_sounds'][key] = str(es.ServerVar("sctf_sound_" + key))
			if not _sctf_opt['game_sounds'][key] in temp_sound_array:
				temp_sound_array.append(_sctf_opt['game_sounds'][key])
				es.dbgmsg(0, "SCTF: Sound added to download: sound/%s" % (_sctf_opt['game_sounds'][key]))
				es.server.queuecmd("downloadable sound/%s" % (_sctf_opt['game_sounds'][key]))
		else:
			_sctf_opt['game_sounds'][key] = None
	#if len(sctf_sound_blue_flag_taken) > 3 and (str(sctf_sound_blue_flag_taken).endswith(".wav") or str(sctf_sound_blue_flag_taken).endswith(".mp3"))
	
	_sctf_opt['flags'].clear()
	_sctf_opt['flags']['ctf_2'] = {}
	_sctf_opt['flags']['ctf_3'] = {}
	timedrop = int(sctf_drop_flag_time)
	if timedrop <= 0:
		timedrop = -99	

	mapname = str(es.ServerVar('eventscripts_currentmap'))
	if _sctf_mapflag.has_key(mapname):
		if _sctf_mapflag[mapname].has_key('red'):
			_sctf_mapflag[mapname]['red'] = _sctf_mapflag[mapname]['red'].strip()
			#_sctf_opt['flags']['ctf_2']['x'], _sctf_opt['flags']['ctf_2']['y'], _sctf_opt['flags']['ctf_2']['z'] = _sctf_mapflag[mapname]['red'].split(' ', 3)
			x, y, z = _sctf_mapflag[mapname]['red'].split(' ', 3)
			_sctf_opt['flags']['ctf_2']['defcoord'] = _sctf_mapflag[mapname]['red']
			_sctf_opt['flags']['ctf_2']['currentcoord'] = _sctf_mapflag[mapname]['red']
			_sctf_opt['flags']['ctf_2']['color'] = "Red"
			_sctf_opt['flags']['ctf_2']['status'] = 0
			_sctf_opt['flags']['ctf_2']['team'] = 2
			_sctf_opt['flags']['ctf_2']['timedrop'] = timedrop
			_sctf_opt['flags']['ctf_2']['owner'] = 0
			_sctf_opt['flags']['ctf_2']['x'] = float(x)
			_sctf_opt['flags']['ctf_2']['y'] = float(y)
			_sctf_opt['flags']['ctf_2']['z'] = float(z)
			_sctf_opt['flags']['ctf_2']['dx'] = 0
			_sctf_opt['flags']['ctf_2']['dy'] = 0
			_sctf_opt['flags']['ctf_2']['dz'] = 0
			_sctf_opt['flags']['ctf_2']['mdlindex'] = 0
			_sctf_opt['flags']['ctf_2']['ispeech'] = -1
		if _sctf_mapflag[mapname].has_key('blue'):
			_sctf_mapflag[mapname]['blue'] = _sctf_mapflag[mapname]['blue'].strip()
			#_sctf_opt['flags']['ctf_3']['x'], _sctf_opt['flags']['ctf_3']['y'], _sctf_opt['flags']['ctf_3']['z'] = _sctf_mapflag[mapname]['blue'].split(' ', 3)
			x, y, z = _sctf_mapflag[mapname]['blue'].split(' ', 3)
			_sctf_opt['flags']['ctf_3']['defcoord'] = _sctf_mapflag[mapname]['blue']
			_sctf_opt['flags']['ctf_3']['currentcoord'] = _sctf_mapflag[mapname]['blue']
			_sctf_opt['flags']['ctf_3']['color'] = "Blue"
			_sctf_opt['flags']['ctf_3']['status'] = 0
			_sctf_opt['flags']['ctf_3']['team'] = 3
			_sctf_opt['flags']['ctf_3']['timedrop'] = timedrop
			_sctf_opt['flags']['ctf_3']['owner'] = 0
			_sctf_opt['flags']['ctf_3']['x'] = float(x)
			_sctf_opt['flags']['ctf_3']['y'] = float(y)
			_sctf_opt['flags']['ctf_3']['z'] = float(z)
			_sctf_opt['flags']['ctf_3']['dx'] = 0
			_sctf_opt['flags']['ctf_3']['dy'] = 0
			_sctf_opt['flags']['ctf_3']['dz'] = 0
			_sctf_opt['flags']['ctf_3']['mdlindex'] = 0
			_sctf_opt['flags']['ctf_3']['ispeech'] = -1
	

	es.loadevents("declare", _sctf_opt['game_options']['data_path'] + "sctf_events.res")

	#Assert time
	if sctf_clean_ground_time < 1 or sctf_clean_ground_time > 180:
		sctf_clean_ground_time.set(random.randint(1, 180))
		
	_sctf_opt['game_options']['clean_idle'] = float(sctf_clean_ground_time)	
	gamethread.delayedname(_sctf_opt['game_options']['clean_idle'], "clean_idle", sctf_delayed_funcs, ("clean"))
	gamethread.delayedname(1, "repeat1s", sctf_delayed_funcs, ("repeat1s"))
	sctf_load_admins()
	
def requirements():
	if not es.exists("variable", "est_version"):
		return False
	return True
def cmdfilter(userid, args):
	if args[0].lower() == "drop":
		if int(sctf_restrict_drop) > 0:
			es.tell(userid, "\x04SCTF:\x01 You cant drop your weapons!")
			return False
	return True
		
def load():
	sctf_version.makepublic() 
	sctf.makepublic()
	

	if not requirements():
		es.dbgmsg(0, " ")
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, "Eventscripts (ES): PASSED [%s]" % str(es.ServerVar("eventscripts_ver")))
		es.dbgmsg(0, "EsTools (EST):     FAIL")
		es.dbgmsg(0, " ")
		es.dbgmsg(0, "Script will be unloaded, because not meat the REQUIREMENTS!")
		es.dbgmsg(0, "Please repair or load missing requirement if you haveit")
		es.dbgmsg(0, "Fail requirement can be downloaded at:")
		es.dbgmsg(0, "http://forums.mattie.info/cs/forums/viewtopic.php?t=3413")
		es.dbgmsg(0, "----------------SCTF----------------")
		es.dbgmsg(0, " ")
		es.server.queuecmd("es_unload sctf")
		return False
	
	if not es.exists("command", "sctf_reload_admins"):
		es.regcmd('sctf_reload_admins', 'sctf/sctf_load_admins', 'Reload admins.')
	if not es.exists("command", "sctf_print_admins"):
		es.regcmd('sctf_print_admins', 'sctf/sctf_print_admins', 'Print all admins.')
	if not es.exists("command", "sctf_set_timeleft"):
		es.regcmd('sctf_set_timeleft', 'sctf/sctf_set_timeleft', 'Set timeleft for game end (SCTF Clock).')
	if not es.exists("command", "sctf_print_classes"):
		es.regcmd('sctf_print_classes', 'sctf/sctf_print_classes', 'Print all classes.')
	if not es.exists("command", "sctf_clean_classes"):
		es.regcmd('sctf_clean_classes', 'sctf/sctf_clean_classes', 'Removes all classes.')
	if not es.exists("command", "sctf_set_scorelimit"):
		es.regcmd('sctf_set_scorelimit', 'sctf/sctf_set_scorelimit', 'Set score limit for game (Flag Score).')
	if not es.exists("command", "sctf_add_class"):
		es.regcmd('sctf_add_class', 'sctf/sctf_add_class', 'Add a new class to game.')
	if not es.exists("saycommand", "setflag"):
		es.regsaycmd('setflag', 'sctf/sctf_setflag', 'Set a flag in player location.')
		
	es.server.cmd("alias None \" \";es_xmexec ../%ssctf_server.cfg;es_xmexec ../%ssctf_on_load.cfg" % (_sctf_opt['game_options']['config_short_path'], _sctf_opt['game_options']['config_short_path']))
	es.addons.registerClientCommandFilter(cmdfilter)

	if len(str(es.ServerVar('eventscripts_currentmap'))) > 1:
		reset(True)
		global _sctf_players
		myPlayerList = playerlib.getPlayerList()
		for userid in myPlayerList:
			_sctf_players[userid.userid] = {}
			_sctf_players[userid.userid]['menu'] = 0
			_sctf_players[userid.userid]['menupage'] = 0
			_sctf_players[userid.userid]['class'] = -1
		es.server.queuecmd("est_slay #l")
		es.msg("\x04SCTF:\x01 Killing all players to refresh\x03 CTF\x01")
		
	_sctf_stats.xexecute("CREATE TABLE IF NOT EXISTS [server] (\
[id] INTEGER  PRIMARY KEY AUTOINCREMENT NOT NULL,\
[version] FLOAT DEFAULT '1.0' UNIQUE NOT NULL,\
[since] VARCHAR(15)  NOT NULL,\
[time] TIME DEFAULT CURRENT_TIME NULL,\
[date] DATE DEFAULT CURRENT_DATE NULL,\
[timestamp] TIMESTAMP DEFAULT CURRENT_TIMESTAMP NULL)")

	_sctf_stats.xexecute("CREATE TABLE IF NOT EXISTS [players] (\
[id] INTEGER  NOT NULL PRIMARY KEY,\
[name] VARCHAR(70) DEFAULT 'NULL' NOT NULL,\
[steamid] VARCHAR(40)  UNIQUE NOT NULL,\
[lastConnect]  VARCHAR(30)  NOT NULL,\
[flag_score] INTEGER DEFAULT '0' NULL,\
[flag_taken] INTEGER DEFAULT '0' NULL,\
[flag_drop] INTEGER DEFAULT '0' NULL,\
[flag_return] INTEGER DEFAULT '0' NULL,\
[spawns] INTEGER DEFAULT '0' NULL,\
[deaths] INTEGER DEFAULT '0' NULL,\
[kills] INTEGER DEFAULT '0' NULL,\
[points] INTEGER DEFAULT '0' NULL)")

	result = _sctf_stats.xquery("SELECT version FROM server WHERE id = 1")
	if len(result) == 0:
		_sctf_stats.xexecute("INSERT INTO server ('version', 'since') VALUES (%i, '%s')" % (_sctf_opt['dev']['db_version'], info.version))
	
def unload():
	sctf.set("0")
	es.server.cmd("es_xmexec ../%ssctf_on_unload.cfg" % _sctf_opt['game_options']['config_short_path'])
	
	_sctf_stats.close()
	es.unregsaycmd("setflag")
	es.addons.unregisterClientCommandFilter(cmdfilter)

	
	gamethread.cancelDelayed("clean_idle")
	gamethread.cancelDelayed("repeat1s")
	
def es_map_start(event_var):
	reset()
	if int(sctf_stats) > 0 and int(sctf_remove_inactive_players_after) > 0:
		date = datetime.date.today() - datetime.timedelta(int(sctf_remove_inactive_players_after))
		es.dbgmsg(0, "SCTF: Removing inactive players util: %s" % date)
		_sctf_stats.xexecute("DELETE FROM players WHERE lastConnect < '%s'" % date)
		
	
	#es.precachemodel('models/mapmodels/pole.mdl')
	#es.precachemodel('models/mapmodels/flags.mdl')
	#es.precachemodel('models/mapmodels/flags2.mdl')
	 

def player_changename(event_var):
	_sctf_stats.execute("UPDATE players SET name='%s' WHERE steamid = '%s'" % (event_var['newname'], event_var['es_steamid']))

def player_activate(event_var):
	gamethread.delayed(10, sctf_delayed_funcs, ("welcome", event_var['userid']))

	global _sctf_players
	userid = int(event_var['userid'])
	_sctf_players[userid] = {}
	_sctf_players[userid]['menu'] = 0
	_sctf_players[userid]['menupage'] = 0
	_sctf_players[userid]['class'] = -1
	if not event_var['es_steamid'] == "BOT":
		result = _sctf_stats.xquery("SELECT steamid FROM players WHERE steamid = '%s'" % event_var['es_steamid'])
		if result:
			datetime.date.today()
			_sctf_stats.execute("UPDATE players SET name='%s',lastConnect='%s' WHERE steamid = '%s'" % (event_var['es_username'], datetime.date.today(), event_var['es_steamid']))
		else:
			_sctf_stats.execute("INSERT INTO players ('name', 'steamid', 'lastConnect') VALUES ('%s', '%s', '%s')" % (event_var['es_username'], event_var['es_steamid'], datetime.date.today()))
			
def player_team(event_var):
	global _sctf_players
	if int(event_var['team']) > 1:
		userid = int(event_var['userid'])
		_sctf_players[userid] = {}
		_sctf_players[userid]['menu'] = 0
		_sctf_players[userid]['menupage'] = 0
		_sctf_players[userid]['class'] = -1
		gamethread.delayed(3, sctf_delayed_funcs, ("autorespawn", userid))

def es_client_command(event_var):
	#if (event_var(command) = "!sctfclasses") then if (server_var(sctf_classes) = 1) then es_xdoblock sctf/sctf_classes_menu
	if event_var['command'] == "menuselect":
		if _sctf_players[int(event_var['userid'])]['menu'] == 1:
			sctf_handle_classes_menu(event_var['userid'], int(event_var['es_userteam']), event_var['commandstring'])
			return None

def round_start(event_var):
	global _sctf_opt
	_sctf_opt['game_options']['round_end'] = False
	initFlags()
	resetFlags()
	es.msg("\x04SCTF:\x01 Lets move guys, protect own\x03 Flag\x01 And capture the enemy\x03 Flag\x01!")

def round_end(event_var):
	global _sctf_opt
	_sctf_opt['game_options']['round_end'] = True
	#es.server.cmd("est_slay #l")
	resetFlags()

def player_spawn(event_var):
	if int(event_var['es_userteam']) > 1:
		global _sctf_players
		userid = int(event_var['userid'])
		if int(sctf_remove_money) > 0:
			es.setplayerprop(event_var['userid'], "CCSPlayer.m_iAccount", 0)
		if int(sctf_stats) > 0:
			if not event_var['es_steamid'] == "BOT":
				_sctf_stats.xexecute("UPDATE players SET spawns = spawns+1 WHERE steamid = '%s'" % event_var['es_steamid'])
		
		if int(sctf_use_classes) > 0:
			if _sctf_classes.count(int(event_var['es_userteam'])):
				if _sctf_players[userid]['class'] == -1:
					if not event_var['es_steamid'] == "BOT":
						sctf_send_classes_menu(userid, 0)
					else:
						_sctf_players[userid]['class'] = _sctf_classes.randomClass(int(event_var['es_userteam']))
						_sctf_classes.applyClass2Player(userid, int(event_var['es_userteam']), _sctf_players[userid]['class'])
				else:
					_sctf_classes.applyClass2Player(userid, int(event_var['es_userteam']), _sctf_players[userid]['class'])

def player_disconnect(event_var):
	if int(event_var['es_userteam']) <= 1:
		return
	
	del _sctf_players[int(event_var['userid'])]
	for flag in _sctf_opt['flags']:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			continue
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			continue
		
		if _sctf_opt['flags'][flag]['owner'] == int(event_var['userid']):
			soundToPlay = _sctf_opt['game_sounds'][_sctf_opt['flags'][flag]['color'].lower()+"_flag_return"]
			if soundToPlay is not None:
				myPlayerList = playerlib.getPlayerList()
				for userid in myPlayerList:
					es.playsound(userid.userid, soundToPlay, 1.0)
						
			es.centermsg("%s Flag returned! (Disconnected)" % _sctf_opt['flags'][flag]['color'])
			es.msg("\x04SCTF:\x03 %s\x01 Flag\x01 returned! (\x03Disconnected\x01)" % _sctf_opt['flags'][flag]['color'])
			
			revflagColor = "Blue"
			if _sctf_opt['flags'][flag]['team'] == 3:
				revflagColor = "Red"
			
			resetFlags(flag)
			
			es.event("initialize", "sctf_flag")
			es.event("setint", "sctf_flag", "userid", 0)
			es.event("setstring", "sctf_flag", "team", revflagColor.lower())
			es.event("setint", "sctf_flag", "rason", 4)
			es.event("setstring", "sctf_flag", "rason_sz", "return")
			es.event("fire", "sctf_flag")
			
			break

#def sctf_flag(event_var):
#	es.msg("Userid: %s | team: %s | rason: %s | rasonSZ: %s" % (event_var['userid'], event_var['team'], event_var['rason'], event_var['rason_sz']))
	
def player_death(event_var):
	if int(event_var['es_userteam']) <= 1:
		return
	flagDrop(event_var['userid'], event_var['es_username'])
	if int(sctf_remove_money) > 0:
		es.setplayerprop(event_var['userid'], "CCSPlayer.m_iAccount", 0)
		
	if int(sctf_use_classes) > 0:
		es.tell(event_var['userid'], "\x04SCTF:\x01 Say\x03 class\x01 to change you class!")
	
	if int(sctf_auto_spawn) > 0:
		if float(sctf_spawn_delay) >= 1.0:
			gamethread.delayed(float(sctf_spawn_delay), sctf_delayed_funcs, ("autorespawn", int(event_var['userid'])))
		else:
			es.server.queuecmd("est_spawn %s" % event_var['userid'])
			
	es.server.cmd("est_RemoveIdle weapon_;est_RemoveIdle item_")
	
	if int(sctf_stats) > 0:
		_sctf_stats.xexecute("UPDATE players SET deaths = deaths+1 WHERE steamid = '%s'" % event_var['es_steamid'])
		if not int(event_var['userid']) == int(event_var['attacker']):
			if not event_var['es_attackersteamid'] == "BOT":
				_sctf_stats.xexecute("UPDATE players SET kills = kills+1 WHERE steamid = '%s'" % event_var['es_attackersteamid'])

def player_say(event_var):
	if event_var['es_steamid'] == "BOT":
		return None
	if event_var['text'][0:5] == "class":
		if int(sctf_use_classes) > 0:
			userid = int(event_var['userid'])
			_sctf_players[userid]['menupage'] = 0
			sctf_send_classes_menu(event_var['userid'])
		else:
			es.tell(event_var['userid'], "\x04SCTF:\x01 Classes are currently\x03 disabled\x01!")
		return None
	if event_var['text'][0:8] == "flagstat":
		if int(sctf_stats) > 0:
			result = _sctf_stats.xquery("SELECT spawns,deaths,kills,flag_taken,flag_score,flag_drop,flag_return FROM players WHERE steamid = '%s'" % event_var['es_steamid'])
			result = result[0]
			es.menu(0, event_var['userid'], "SCTF v%s <-> By Sn4k3\\n \\nMy Stats:\\n->1. Spawns: %i\\n->2. Deaths: %i\\n->3. Kills: %i\\n->4. Flags Captured: %i\\n->5. Flags Score: %i\\n->6. Flags Drop: %i\\n->7. Flags Return: %i\\n \\n0. Exit" % (str(sctf_version), result[0], result[1], result[2], result[3], result[4], result[5], result[6]))
		else:
			es.tell(event_var['userid'], "\x04SCTF:\x01 Stats is currently disabled")
		return None
	
def est_box_trigger(event_var):
	if not (event_var['boxname'] == "sctf_red_flag" or event_var['boxname'] == "sctf_blue_flag"):
		return None
	global _sctf_opt
	flag = "ctf_3"
	if event_var['boxname'] == "sctf_red_flag":
		flag = "ctf_2"
		
	flagcolor = "Blue"
	opteam = 3
	if _sctf_opt['flags'][flag]['team'] == 3:
		flagcolor = "Red"
		opteam = 2

	opteamString = "ctf_%i" % opteam
	if int(event_var['es_userteam']) == _sctf_opt['flags'][flag]['team']: # check for score an captured flag
		if _sctf_opt['flags'][flag]['status'] == 0: # Allowed to score
			if _sctf_opt['flags'][opteamString]['owner'] == int(event_var['userid']): # That userid have the flag!
				pname = es.getplayername(event_var['userid'])
				psteamid = es.getplayersteamid(event_var['userid'])
					
				es.centermsg("%s Team Score! (%s)" % (_sctf_opt['flags'][flag]['color'], pname))
				es.msg("\x04SCTF:\x03 %s\x01 Team Score! (\x03%s\x01)" % (_sctf_opt['flags'][flag]['color'], pname))
				#todo if (server_var(sctf_flag_score_add_kills_for_team) != 0) then es est_KillAdd #t server_var(sctf_flag_score_add_kills_for_team)
				#todo es_msg #multi #green SCTF:#default Red Team Wins#lightgreen server_var(sctf_flag_score_add_kills_for_team)#default Points For Flag Score!
					
				es.emitsound("player", event_var['userid'], "weapons/explode3.wav" ,1.0, 0.5)
				es.emitsound("player", event_var['userid'], "weapons/explode4.wav" ,1.0, 0.5)
				es.emitsound("player", event_var['userid'], "weapons/explode5.wav" ,1.0, 0.5)
					
				if int(sctf_sacrifice_for_score) > 0:
					es.server.cmd("est_slay %s\nest_deathAdd %s -1" % (event_var['userid'], event_var['userid']))
					
				if int(sctf_score_for_score_flag) > 0:
					es.server.cmd("est_KillAdd %s %s" % (event_var['userid'], sctf_score_for_score_flag))
					es.tell(event_var['userid'], "\x04SCTF:\x01 You win\x03 %s\x01 Kill(s) for\x03 Flag Score\x01!" % sctf_score_for_score_flag)
					
				flagScoreKey = _sctf_opt['flags'][flag]['color'].lower()+"_score"
				_sctf_opt['game_options'][flagScoreKey] += 1
					
				resetFlags(opteamString)
				# todo es est_SetPlayerColor server_var(sctf_coord) 255 255 255 255

				es.event("initialize", "sctf_flag")
				es.event("setint", "sctf_flag", "userid", int(event_var['userid']))
				es.event("setstring", "sctf_flag", "team", _sctf_opt['flags'][flag]['color'].lower())
				es.event("setint", "sctf_flag", "rason", 2)
				es.event("setstring", "sctf_flag", "rason_sz", "score")
				es.event("fire", "sctf_flag")
					
				if _sctf_opt['game_options']['score_limit'] > 0 and _sctf_opt['game_options'][flagScoreKey] >= _sctf_opt['game_options']['score_limit']:
					endGame()
				else:
					scoreSound = _sctf_opt['game_sounds'][_sctf_opt['flags'][flag]['color'].lower()+"_team_score"]
					if scoreSound is not None:
						myPlayerList = playerlib.getPlayerList()
						for fuserid in myPlayerList:
							es.playsound(fuserid.userid, scoreSound, 1.0)
							
				if int(sctf_stats) > 0:
					_sctf_stats.xexecute("UPDATE players SET flag_score = flag_score+1 WHERE steamid = '%s'" % psteamid)
		elif _sctf_opt['flags'][flag]['status'] == 2: # Allowed to return dropped flag
			pteam = es.getplayerteam(event_var['userid'])
			pname = es.getplayername(event_var['userid'])
			psteamid = es.getplayersteamid(event_var['userid'])
			resetFlags(flag)
						
			soundToPlay = _sctf_opt['game_sounds'][_sctf_opt['flags'][flag]['color'].lower()+"_flag_return"]
			if soundToPlay is not None:
				myPlayerList = playerlib.getPlayerList()
				for fuserid in myPlayerList:
					es.playsound(fuserid.userid, soundToPlay, 1.0)
					
			es.centermsg("%s Flag returned! (%s)" % (_sctf_opt['flags'][flag]['color'], pname))
			es.msg("\x04SCTF:\x03 %s\x01 Flag\x01 returned! (\x03%s\x01)" % (_sctf_opt['flags'][flag]['color'], pname))
			if int(sctf_score_for_return_flag) > 0:
				es.server.cmd("est_KillAdd %s %s" % (event_var['userid'], sctf_score_for_return_flag)) 
				es.tell(event_var['userid'], "\x04SCTF:\x01 You won\x03 %s\x01 Kill(s) for Flag Return" % sctf_score_for_return_flag)
							
			es.event("initialize", "sctf_flag")
			es.event("setint", "sctf_flag", "userid", int(event_var['userid']))
			es.event("setstring", "sctf_flag", "team", _sctf_opt['flags'][flag]['color'].lower())
			es.event("setint", "sctf_flag", "rason", 4)
			es.event("setstring", "sctf_flag", "rason_sz", "return")
			es.event("fire", "sctf_flag")

			if int(sctf_stats) > 0:
				_sctf_stats.xexecute("UPDATE players SET flag_return = flag_return+1 WHERE steamid = '%s'" % psteamid)
	else: # Enemy team under flag
		captureFlag(event_var['userid'], flag)
	return None
######################################################################
	
def sctf_send_classes_menu(userid, time = 0):
	userid = int(userid)
	team = int(es.getplayerteam(userid))
	if not team:
		return None
	if len(_sctf_classes_opt[team]) == 0:
		es.tell(userid, "\x04SCTF:\x01 There are no\x03 Classes\x01 created")
		return None
	global _sctf_players
	_sctf_players[userid]['menu'] = 1
	menu_str = "SCTF v%s <-> By Sn4k3\\nClasses (%i/%i):\\n \\n" % (str(info.version), _sctf_players[userid]['menupage']+1, _sctf_classes.getMenuPages(team))
	i = 0
	index = 7*_sctf_players[userid]['menupage']
	keys = "0"
	userid = int(userid)
	lenClasses = len(_sctf_classes_opt[team])
	while index < lenClasses:
	#for index in _sctf_classes_opt:
		i += 1
		menu_str += "->%i. %s [%i HP] [%s Speed]\\n%s\\n" % (i, _sctf_classes_opt[team][index]['name'], _sctf_classes_opt[team][index]['health'], str(_sctf_classes_opt[team][index]['speed']), _sctf_classes_opt[team][index]['desc'])
		keys += "%i" % i
		index += 1
		if i == 7:
			break
	
	if _sctf_players[userid]['menupage'] > 0:
		keys += "8"
		menu_str += " \\n->8. Back"
	else:
		menu_str += " \\n8. Back"
	if lenClasses > index:
		keys += "9"
		menu_str += "\\n->9. Next"
	else:
		menu_str += "\\n9. Next"
	menu_str += "\\n0. Random"
	es.menu(time, userid, menu_str, keys)
	
def sctf_handle_classes_menu(userid, team, num):
	global _sctf_players
	userid = int(userid)
	num = int(num)
	oldClass = _sctf_players[userid]['class']
		
	if num == 8:
		es.playsound(userid, _sctf_opt['dev_sounds']['menuback'], 1.0)
		_sctf_players[userid]['menupage'] -= 1
		sctf_send_classes_menu(userid, 0)
		return True
	elif num == 9:
		es.playsound(userid, _sctf_opt['dev_sounds']['menunext'], 1.0)
		_sctf_players[userid]['menupage'] += 1
		sctf_send_classes_menu(userid, 0)
		return True
	elif num == 10:
		es.playsound(userid, _sctf_opt['dev_sounds']['menuselect'], 1.0)
		_sctf_players[userid]['menu'] = 0
		_sctf_players[userid]['class'] = _sctf_classes.randomClass(team)
	else:
		es.playsound(userid, _sctf_opt['dev_sounds']['menuselect'], 1.0)
		_sctf_players[userid]['menu'] = 0
		_sctf_players[userid]['class'] = 7*_sctf_players[userid]['menupage']+num-1
		if not _sctf_classes.isValidIndex(_sctf_players[userid]['class'], team):
			_sctf_players[userid]['class'] = -1

	if oldClass >= 0:
		es.tell(userid, "\x04SCTF:\x01 You will respawn as\x03 %s\x01" % _sctf_classes_opt[team][_sctf_players[userid]['class']]['name'])
		return True	
	if playerlib.getPlayer(userid).attributes['isdead']: # user is dead
		es.tell(userid, "\x04SCTF:\x01 You will respawn as\x03 %s\x01" % _sctf_classes_opt[team][_sctf_players[userid]['class']]['name'])
		return True
		
	_sctf_classes.applyClass2Player(userid, team, _sctf_players[userid]['class'])
	
def sctf_status_to_string(status):
	if status == 0:
		return "UnCaptured"
	elif status == 1:
		return "Captured"
	else:
		return "Drop"

def sctf_show_status_hud():
	text = "SCTF Status:"
	if _sctf_opt['game_options']['game_time'] > -1:
		text += " %is Left" % int(_sctf_opt['game_options']['game_time'])
		
	text += "\\n"

	for flag in _sctf_opt['flags']:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			continue
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			continue
		text += "%s Flag: " % _sctf_opt['flags'][flag]['color']
		if _sctf_opt['flags'][flag]['status'] == 0:
			text += "Idle\\n"
		elif _sctf_opt['flags'][flag]['status'] == 2:
			text += "Drop"
			if _sctf_opt['flags'][flag]['timedrop'] > 0:
				text += " (%is)" % _sctf_opt['flags'][flag]['timedrop']
			text += "\\n"
		elif _sctf_opt['flags'][flag]['owner'] > 0:
			pname = es.getplayername(_sctf_opt['flags'][flag]['owner'])
			text += "%s\\n" % pname
		
		text += "%s Team Score: %i" % (_sctf_opt['flags'][flag]['color'], _sctf_opt['game_options'][_sctf_opt['flags'][flag]['color'].lower()+"_score"])
		if _sctf_opt['game_options']['score_limit'] > 0:
			text += "/%i" % _sctf_opt['game_options']['score_limit']
			
		text += "\\n"
	
	lenit = len(text) - 2
	es.server.cmd("est_hsay #h %s" % text[0:lenit])

def sctf_add_class():
	if es.getargv() <= 7:
		es.dbgmsg(0, "Syntax: %s <name> <description> <health> <speed> <\"weapons:ammo\"> [team] [model]" % es.getargv(0))
		return None
	name = es.getargv(1)
	desc = es.getargv(2)
	health = int(es.getargv(3))
	speed = float(es.getargv(4))
	weapons = es.getargv(5)
	team = es.getargv(6)
	model = es.getargv(7)
	if not model:
		model = None
	_sctf_classes.addClass(name, desc, health, speed, weapons, team, model)
	
def sctf_clean_classes():
	_sctf_classes.reset()

def sctf_load_admins():
	_sctf_admins.load()
	
def sctf_print_admins():
	_sctf_admins.printAll()
	
def sctf_print_classes():
	_sctf_classes.printAll()
	
def sctf_setflag():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if not _sctf_admins.isAdmin(steamid):
		es.tell(userid, "\x04SCTF:\x01 You are not autorized to use admin commands (\x03%s\x01)" % es.getargv(0))
		return

	if playerlib.getPlayer(userid).get("isdead"):
		es.tell(userid, "\x04SCTF:\x01 You must be alive to use that command (\x03%s\x01)" % es.getargv(0))
		return
	x, y, z = es.getplayerlocation(userid)
	argv = es.getargv(1)
	team = 3
	flag = None
	color = "Blue"
	if argv[0:1] == "2" or argv[0:1] == "t" or argv[0:1] == "r":
		flag = "ctf_2"
		team = 2
		color = "Red"
	elif argv[0:1] == "3" or argv[0:1] == "c" or argv[0:1] == "b":
		flag = "ctf_3"
	else:
		team = int(es.getplayerteam(userid))
		if team == 2:
			color = "Red"
		flag = "ctf_%i" % team
	if not flag:
		return

	timedrop = int(sctf_drop_flag_time)
	if timedrop <= 0:
		timedrop = -99	
		
	_sctf_opt['flags'][flag]['defcoord'] = "%s %s %s" % (x, y, z)
	_sctf_opt['flags'][flag]['currentcoord'] = _sctf_opt['flags'][flag]['defcoord']
	_sctf_opt['flags'][flag]['color'] = color
	_sctf_opt['flags'][flag]['status'] = 0
	_sctf_opt['flags'][flag]['team'] = team
	_sctf_opt['flags'][flag]['timedrop'] = timedrop
	_sctf_opt['flags'][flag]['owner'] = 0
	_sctf_opt['flags'][flag]['x'] = float(x)
	_sctf_opt['flags'][flag]['y'] = float(y)
	_sctf_opt['flags'][flag]['z'] = float(z)
	_sctf_opt['flags'][flag]['dx'] = 0
	_sctf_opt['flags'][flag]['dy'] = 0
	_sctf_opt['flags'][flag]['dz'] = 0
	
	mapname = str(es.ServerVar('eventscripts_currentmap'))
	#if not _sctf_mapflag.has_key(mapname)
	#	_sctf_mapflag[mapname] = {}
	#_sctf_mapflag[mapname][color.lower()] = _sctf_opt['flags'][flag]['defcoord']
	if not _sctf_mapflag.has_key(mapname):
		_sctf_mapflag[mapname] = {}
	_sctf_mapflag[mapname][color.lower()] = _sctf_opt['flags'][flag]['defcoord']
	_sctf_mapflag.write()
	
	es.msg("\x04SCTF:\x01 New \x03%s\x01 Flag placed on map (\x03%s\x01)" % (color, _sctf_opt['flags'][flag]['defcoord']))
	
def sctf_set_timeleft():
	if es.getargc() <= 1:
		es.dbgmsg(0, "Syntax: %s <Time in Minutes (Lessthan 1 = Disable)>" % es.getargv(0))
		return
	argv = float(es.getargv(1))
	if argv >= 1:
		_sctf_opt['game_options']['game_time'] = argv*60
	else:
		_sctf_opt['game_options']['game_time'] = -99
		
		
def sctf_set_scorelimit():
	if es.getargc() <= 1:
		es.dbgmsg(0, "Syntax: %s <Score (Lesstan 1 = Disable)>" % es.getargv(0))
		return
	argv = int(es.getargv(1))
	if argv >= 1:
		_sctf_opt['game_options']['score_limit'] = argv
	else:
		_sctf_opt['game_options']['score_limit'] = -99
		
def endGame():
	userid = int(es.getuserid())
	es.server.cmd("es_give %i game_end;es_fire %i game_end EndGame" % (userid,userid))
	
	es.event("initialize", "sctf_gameend")
	if _sctf_opt['game_options']['game_time'] == -99:
		es.event("setint", "sctf_gameend", "timeleft", -1)
	else:
		es.event("setint", "sctf_gameend", "timeleft", _sctf_opt['game_options']['game_time'])

	if _sctf_opt['game_options']['blue_score'] > _sctf_opt['game_options']['red_score']: # blues win
		es.event("setint", "sctf_gameend", "winners", 3)
		es.event("setint", "sctf_gameend", "winners_score", _sctf_opt['game_options']['blue_score'])
		es.event("setint", "sctf_gameend", "lossers", 2)
		es.event("setint", "sctf_gameend", "lossers_score", _sctf_opt['game_options']['red_score'])
		es.event("setint", "sctf_gameend", "draw", 0)
		es.msg("\x04SCTF:\x01 \x03Blue Team\x01 was won the match! (\x03%i\x01-\x03%i\x01)" % (_sctf_opt['game_options']['blue_score'], _sctf_opt['game_options']['red_score']))
		if _sctf_opt['game_sounds']['blue_team_wins'] is not None:
			myPlayerList = playerlib.getPlayerList("#ct")
			for userid in myPlayerList:
				es.playsound(userid.userid, _sctf_opt['game_sounds']['blue_team_wins'], 1.0)
		if _sctf_opt['game_sounds']['red_team_lose'] is not None:
			myPlayerList = playerlib.getPlayerList("#t")
			for userid in myPlayerList:
				es.playsound(userid.userid, _sctf_opt['game_sounds']['red_team_lose'], 1.0)
	elif _sctf_opt['game_options']['blue_score'] < _sctf_opt['game_options']['red_score']: # reds win
		es.event("setint", "sctf_gameend", "winners", 2)
		es.event("setint", "sctf_gameend", "winners_score", _sctf_opt['game_options']['red_score'])
		es.event("setint", "sctf_gameend", "lossers", 3)
		es.event("setint", "sctf_gameend", "lossers_score", _sctf_opt['game_options']['blue_score'])
		es.event("setint", "sctf_gameend", "draw", 0)
		es.msg("\x04SCTF:\x01 \x03Red Team\x01 was won the match! (\x03%i\x01-\x03%i\x01)" % (_sctf_opt['game_options']['red_score'], _sctf_opt['game_options']['blue_score']))
		if _sctf_opt['game_sounds']['red_team_wins'] is not None:
			myPlayerList = playerlib.getPlayerList("#t")
			for userid in myPlayerList:
				es.playsound(userid.userid, _sctf_opt['game_sounds']['red_team_wins'], 1.0)
		if _sctf_opt['game_sounds']['blue_team_lose'] is not None:
			myPlayerList = playerlib.getPlayerList("#ct")
			for userid in myPlayerList:
				es.playsound(userid.userid, _sctf_opt['game_sounds']['blue_team_lose'], 1.0)
	elif _sctf_opt['game_options']['blue_score'] == _sctf_opt['game_options']['red_score']: # draw
		es.event("setint", "sctf_gameend", "winners", 0)
		es.event("setint", "sctf_gameend", "winners_score", _sctf_opt['game_options']['blue_score'])
		es.event("setint", "sctf_gameend", "lossers", 0)
		es.event("setint", "sctf_gameend", "lossers_score", _sctf_opt['game_options']['red_score'])
		es.event("setint", "sctf_gameend", "draw", 1)
		es.msg("\x04SCTF:\x01 Game end in a \x03Draw\x01! (\x03%i\x01-\x03%i\x01)" % (_sctf_opt['game_options']['red_score'], _sctf_opt['game_options']['blue_score']))
		if _sctf_opt['game_sounds']['draw'] is not None:
			myPlayerList = playerlib.getPlayerList()
			for userid in myPlayerList:
				es.playsound(userid.userid, _sctf_opt['game_sounds']['draw'], 1.0)

	es.event("fire", "sctf_gameend")
	
def initFlags():
	userid = es.getuserid()
	mdlPoleIndex = es.precachemodel("models/mapmodels/pole.mdl")
	converter = {}
	converter['sctf_blue_flag'] = es.precachemodel("models/mapmodels/flags.mdl") # Blue
	converter['sctf_red_flag'] = es.precachemodel("models/mapmodels/flags2.mdl") # Red
	global _sctf_opt
	for flag in _sctf_opt['flags']:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			continue
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			continue
			
		x = float(_sctf_opt['flags'][flag]['x'])
		y = float(_sctf_opt['flags'][flag]['y'])
		z = float(_sctf_opt['flags'][flag]['z'])
		boxname = "sctf_%s_flag" % _sctf_opt['flags'][flag]['color'].lower()
		
		# Pole
		es.server.cmd("es_xprop_dynamic_create %s \"props_c17/fence01a.mdl\";es est_setentname server_var(eventscripts_lastgive) %s_pole" % (userid, boxname))
		lgindex = es.ServerVar('eventscripts_lastgive')
		es.setindexprop(lgindex, "CBaseEntity.m_nModelIndex", mdlPoleIndex)
		es.setindexprop(lgindex, "CBaseEntity.m_clrRender", -1)
		es.setindexprop(lgindex, "CBaseEntity.m_angRotation", "0,0,0")
		es.server.cmd("est_EntTeleport %s %f %f %f" % (lgindex, x, y, z))
		
		# Flag
		es.server.cmd("es_xprop_dynamic_create %s \"props_c17/fence01a.mdl\";es est_setentname server_var(eventscripts_lastgive) %s" % (userid, boxname))
		lgindex = int(es.ServerVar('eventscripts_lastgive'))
		_sctf_opt['flags'][flag]['mdlindex'] = lgindex
		es.setindexprop(lgindex, "CBaseEntity.m_nModelIndex", converter[boxname])
		es.setindexprop(lgindex, "CBaseEntity.m_clrRender", -1)
		es.setindexprop(lgindex, "CBaseEntity.m_angRotation", "0,0,0")
		es.server.cmd("est_EntTeleport %i %f %f %f;es_xfire %s %s addoutput \"targetname %s\"\;es_xfire %s %s SetAnimation flag_idle1" % (lgindex, x, y, z, userid, boxname, boxname, userid, boxname))

		resetFlags()
	
def resetFlags(flag = None):
	timedrop = int(sctf_drop_flag_time)
	if timedrop <= 0:
		timedrop = -99	
	if flag is None:
		for flag in _sctf_opt['flags']:
			if not _sctf_opt['flags'][flag].has_key('defcoord'):
				continue
			if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
				continue
			
			if _sctf_opt['flags'][flag]['ispeech'] > -1:
				es.server.cmd("es_xremove %i" % _sctf_opt['flags'][flag]['ispeech'])
			_sctf_opt['flags'][flag]['currentcoord'] = _sctf_opt['flags'][flag]['defcoord']
			_sctf_opt['flags'][flag]['status'] = 0
			_sctf_opt['flags'][flag]['owner'] = 0
			_sctf_opt['flags'][flag]['dx'] = 0
			_sctf_opt['flags'][flag]['dy'] = 0
			_sctf_opt['flags'][flag]['dz'] = 0
			_sctf_opt['flags'][flag]['timedrop'] = timedrop
			_sctf_opt['flags'][flag]['ispeech'] = -1
			
			x = float(_sctf_opt['flags'][flag]['x'])
			y = float(_sctf_opt['flags'][flag]['y'])
			z = float(_sctf_opt['flags'][flag]['z'])
			boxname = "sctf_%s_flag" % _sctf_opt['flags'][flag]['color'].lower()
			es.server.cmd("est_Box_Remove %s;est_EntTeleport %i %s %s %s;est_SetEntityColor %i 255 255 255 255;est_Box_Trigger #l %s \"%f %f %f\" \"%f %f %f\"" % (boxname, _sctf_opt['flags'][flag]['mdlindex'], _sctf_opt['flags'][flag]['x'],_sctf_opt['flags'][flag]['y'],_sctf_opt['flags'][flag]['z'], _sctf_opt['flags'][flag]['mdlindex'], boxname, x-15,y-15,z-5,x+15,y+15,z+70))
	else:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			return 
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			return 
		
		if _sctf_opt['flags'][flag]['ispeech'] > -1:
			es.server.cmd("es_xremove %i" % _sctf_opt['flags'][flag]['ispeech'])
		_sctf_opt['flags'][flag]['currentcoord'] = _sctf_opt['flags'][flag]['defcoord']
		_sctf_opt['flags'][flag]['status'] = 0
		_sctf_opt['flags'][flag]['owner'] = 0
		_sctf_opt['flags'][flag]['dx'] = 0
		_sctf_opt['flags'][flag]['dy'] = 0
		_sctf_opt['flags'][flag]['dz'] = 0
		_sctf_opt['flags'][flag]['timedrop'] = timedrop
		_sctf_opt['flags'][flag]['ispeech'] = -1
		
		x = float(_sctf_opt['flags'][flag]['x'])
		y = float(_sctf_opt['flags'][flag]['y'])
		z = float(_sctf_opt['flags'][flag]['z'])
		boxname = "sctf_%s_flag" % _sctf_opt['flags'][flag]['color'].lower()
		es.server.cmd("est_Box_Remove %s;est_EntTeleport %i %f %f %f;est_SetEntityColor %i 255 255 255 255;est_Box_Trigger #l %s \"%f %f %f\" \"%f %f %f\"" % (boxname, _sctf_opt['flags'][flag]['mdlindex'], x,y,z, _sctf_opt['flags'][flag]['mdlindex'], boxname, x-15,y-15,z-5,x+15,y+15,z+70))


def drawFlags():
	for flag in _sctf_opt['flags']:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			continue
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			continue
	
		rgba = None
		defrgba = None
		glowMaterial = "sprites/blueglow1.vmt"
		if _sctf_opt['flags'][flag]['team'] == 2:
			defrgba = "255 0 0 255"
			glowMaterial = "sprites/purpleglow1.vmt"
		else:
			defrgba = "0 0 255 255"
			
		rgba = defrgba
		if _sctf_opt['flags'][flag]['status'] > 0:
			rgba = "255 255 255 255"
		
		
		z1 = _sctf_opt['flags'][flag]['z'] + _sctf_opt['flag_maker']['live']['z1']
		z2 = z1 - _sctf_opt['flag_maker']['live']['z2']
		x1 = _sctf_opt['flags'][flag]['x'] + _sctf_opt['flag_maker']['live']['x1']
		es.server.cmd("est_Effect 11 #h 0 %s %s %f 1 255" % (glowMaterial, _sctf_opt['flags'][flag]['defcoord'], _sctf_opt['flag_maker']['live_time']))
		es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['defcoord'], _sctf_opt['flags'][flag]['x'], _sctf_opt['flags'][flag]['y'], z1, _sctf_opt['flag_maker']['live_time'], rgba))
		es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['x'], _sctf_opt['flags'][flag]['y'], z1, x1, _sctf_opt['flags'][flag]['y'], z1, _sctf_opt['flag_maker']['live_time'], rgba))
		es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['x'], _sctf_opt['flags'][flag]['y'], z2, x1, _sctf_opt['flags'][flag]['y'], z2, _sctf_opt['flag_maker']['live_time'], rgba))
		es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (x1, _sctf_opt['flags'][flag]['y'], z2, x1, _sctf_opt['flags'][flag]['y'], z1, _sctf_opt['flag_maker']['live_time'], rgba))
		if _sctf_opt['flags'][flag]['team'] == 3:
			es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['x'], _sctf_opt['flags'][flag]['y'], z1, x1, _sctf_opt['flags'][flag]['y'], z2, _sctf_opt['flag_maker']['live_time'], rgba))
		else:
			es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['x'], _sctf_opt['flags'][flag]['y'], z2, x1, _sctf_opt['flags'][flag]['y'], z1, _sctf_opt['flag_maker']['live_time'], rgba))
			
		if _sctf_opt['flags'][flag]['status'] == 2:
			z1 = _sctf_opt['flags'][flag]['dz'] + _sctf_opt['flag_maker']['drop']['z1']
			z2 = z1 - _sctf_opt['flag_maker']['drop']['z2']
			x1 = _sctf_opt['flags'][flag]['dx'] + _sctf_opt['flag_maker']['drop']['x1']
			#es.server.cmd("est_Effect 11 #h 0 \"sprites/blueglow1.vmt\" %s 1.05412 1 255" % _sctf_opt['flags'][flag]['defcoord'])
			es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['currentcoord'], _sctf_opt['flags'][flag]['dx'], _sctf_opt['flags'][flag]['dy'], z1, _sctf_opt['flag_maker']['live_time'], defrgba))
			es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['dx'], _sctf_opt['flags'][flag]['dy'], z1, x1, _sctf_opt['flags'][flag]['dy'], z1, _sctf_opt['flag_maker']['live_time'], defrgba))
			es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (_sctf_opt['flags'][flag]['dx'], _sctf_opt['flags'][flag]['dy'], z2, x1, _sctf_opt['flags'][flag]['dy'], z2, _sctf_opt['flag_maker']['live_time'], defrgba))
			es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %s %f 2 2 %s" % (x1, _sctf_opt['flags'][flag]['dy'], z2, x1, _sctf_opt['flags'][flag]['dy'], z1, _sctf_opt['flag_maker']['live_time'], defrgba))
			if _sctf_opt['flags'][flag]['team'] == 3:
				es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %f %i 2 2 %s" % (_sctf_opt['flags'][flag]['dx'], _sctf_opt['flags'][flag]['dy'], z1, x1, _sctf_opt['flags'][flag]['dy'], z2, _sctf_opt['flag_maker']['live_time'], defrgba))
			else:
				es.server.cmd("est_Effect 3 #h 0 \"sprites/laserbeam.vmt\" %s %s %s %s %s %f %i 2 2 %s" % (_sctf_opt['flags'][flag]['dx'], _sctf_opt['flags'][flag]['dy'], z2, x1, _sctf_opt['flags'][flag]['dy'], z1, _sctf_opt['flag_maker']['live_time'], defrgba))
				
def drawSpeechIcon(userid, flag):
	global _sctf_opt 
	if _sctf_opt['game_options']['round_end']:
		return None
	converter = {}
	converter['ctf_2'] = "extras/sctf/info_speech_redflag.mdl"
	converter['ctf_3'] = "extras/sctf/info_speech_blueflag.mdl"

	x,y,z = es.getplayerlocation(userid)
	z += 96
	entname = "sctf_"+_sctf_opt['flags'][flag]['color'].lower()+"_flag_carrier"
	es.server.cmd("es_xprop_dynamic_create %s %s;es est_setentname server_var(eventscripts_lastgive) %s" % (userid, converter[flag], entname))
	entindex = int(es.ServerVar('eventscripts_lastgive'))
	es.setindexprop(entindex, "CBaseEntity.m_vecOrigin", "%s,%s,%s" % (x,y,z))
	es.server.cmd("es_xfire %s %s SetParent !activator;es_xfire %s %s SetAnimation idle;es_xfire %s %s addoutput \"angles 0 0 0\";es_xfire %s %s addoutput \"solid 0\"" % (userid, entname, userid, entname, userid, entname, userid, entname))
	_sctf_opt['flags'][flag]['ispeech'] = entindex

	
def captureFlag(userid, flag, fromDrop = False):
	userid = int(userid)
	converter = {}
	converter['ctf_2'] = "sctf_red_flag"
	converter['ctf_3'] = "sctf_blue_flag"
	if es.exists("userid", userid):
		global _sctf_opt
		es.server.cmd("est_Box_Remove %s;est_SetEntityColor %i 0 0 0 0" % (converter[flag], _sctf_opt['flags'][flag]['mdlindex']))
		pname = es.getplayername(userid)
		psteamid = es.getplayersteamid(userid)
		
		timedrop = int(sctf_drop_flag_time)
		if timedrop <= 0:
			timedrop = -99	
		
		revflagColor = "Blue"
		two_type = "capture"
		tree_type = "capture"
		if _sctf_opt['flags'][flag]['team'] == 3:
			revflagColor = "Red"
			tree_type = "taken"
		else:
			two_type = "taken"
				
		flagsound2 = _sctf_opt['game_sounds']["%s_flag_%s" % (revflagColor.lower(), two_type)]
		flagsound3 = _sctf_opt['game_sounds']["%s_flag_%s" % (revflagColor.lower(), tree_type)]
		if flagsound2 is not None:
			myPlayerList = playerlib.getPlayerList("#t")
			for fuserid in myPlayerList:
				es.playsound(fuserid.userid, flagsound2, 1.0)
		if flagsound3 is not None:
			myPlayerList = playerlib.getPlayerList("#ct")
			for fuserid in myPlayerList:
				es.playsound(fuserid.userid, flagsound3, 1.0)
					
		es.centermsg("%s Team has the Flag! (%s)" % (revflagColor, pname))
		es.msg("\x04SCTF:\x03 %s\x01 Team has the Flag! (\x03%s\x01)" % (revflagColor, pname))
				
		if int(sctf_score_for_take_flag) > 0:
			es.server.cmd("est_KillAdd %s +%s" % (userid, sctf_score_for_take_flag))
			es.tell(userid, "\x04SCTF:\x01 You win\x03 %s\x01 Kill(s) for take the flag!" % sctf_score_for_take_flag)
			
		_sctf_opt['flags'][flag]['status'] = 1
		_sctf_opt['flags'][flag]['owner'] = userid
		_sctf_opt['flags'][flag]['timedrop'] = timedrop
		
		drawSpeechIcon(userid, flag)
		
		es.event("initialize", "sctf_flag")
		es.event("setint", "sctf_flag", "userid", userid)
		es.event("setstring", "sctf_flag", "team", revflagColor.lower())
		es.event("setint", "sctf_flag", "rason", 1)
		es.event("setstring", "sctf_flag", "rason_sz", "captured")
		es.event("fire", "sctf_flag")
				
		if int(sctf_stats) > 0:
			_sctf_stats.xexecute("UPDATE players SET flag_taken = flag_taken+1 WHERE steamid = '%s'" % psteamid)

def flagDrop(userid, playername):
	global _sctf_opt
	for flag in _sctf_opt['flags']:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			continue
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			continue
		
		two_type = "drop"
		tree_type = "drop"
		if _sctf_opt['flags'][flag]['team'] == 2:
			tree_type = "lost"
		else:
			two_type = "lost"
			
		if _sctf_opt['flags'][flag]['owner'] == int(userid):
			es.centermsg("%s Flag Lost! (%s)" % (_sctf_opt['flags'][flag]['color'], playername))
			es.msg("\x04SCTF:\x03 %s\x01 Flag Lost! (\x03%s\x01)" % (_sctf_opt['flags'][flag]['color'], playername))
			
			if _sctf_opt['flags'][flag]['ispeech'] > -1:
				es.server.cmd("es_xremove %i" % _sctf_opt['flags'][flag]['ispeech'])
			locx, locy, locz = es.getplayerlocation(userid)
			locz -= _sctf_opt['flag_maker']['drop']['z']
			_sctf_opt['flags'][flag]['currentcoord'] = "%s %s %s" % (locx, locy, locz)
			_sctf_opt['flags'][flag]['owner'] = 0
			_sctf_opt['flags'][flag]['status'] = 2
			_sctf_opt['flags'][flag]['dx'] = locx
			_sctf_opt['flags'][flag]['dy'] = locy
			_sctf_opt['flags'][flag]['dz'] = locz
			_sctf_opt['flags'][flag]['ispeech'] = -1
			
			x = float(locx)
			y = float(locy)
			z = float(locz)
			if int(sctf_score_for_drop_flag) > 0:
				es.server.cmd("est_KillAdd %s -%s" % (userid, sctf_score_for_drop_flag))
				es.tell(userid, "\x04SCTF:\x01 You lost\x03 %s\x01 Kill(s) for Flag Drop!" % sctf_score_for_drop_flag)
				
			es.server.cmd("est_EntTeleport %i %f %f %f;est_SetEntityColor %i 255 255 255 255;est_Box_Trigger #l sctf_%s_flag \"%f %f %f\" \"%f %f %f\"" % (_sctf_opt['flags'][flag]['mdlindex'], x,y,z, _sctf_opt['flags'][flag]['mdlindex'], _sctf_opt['flags'][flag]['color'].lower(), x-15,y-15,z-5,x+15,y+15,z+70))
			
			flagsound2 = _sctf_opt['game_sounds']["%s_flag_%s" % (_sctf_opt['flags'][flag]['color'].lower(), two_type)]
			flagsound3 = _sctf_opt['game_sounds']["%s_flag_%s" % (_sctf_opt['flags'][flag]['color'].lower(), tree_type)]
			if flagsound3 is not None:
				myPlayerList = playerlib.getPlayerList("#ct")
				for fuserid in myPlayerList:
					es.playsound(fuserid.userid, flagsound3, 1.0)
			if flagsound2 is not None:
				myPlayerList = playerlib.getPlayerList("#t")
				for fuserid in myPlayerList:
					es.playsound(fuserid.userid, flagsound2, 1.0)
				
			if int(sctf_stats) > 0:
				_sctf_stats.xexecute("UPDATE players SET flag_drop = flag_drop+1 WHERE steamid = '%s'" % es.getplayersteamid(userid))
				
			break

def checkFlags():
	global _sctf_opt
	for flag in _sctf_opt['flags']:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			continue
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			continue

		es.set("_sctf_temp", 0)
		
		filter = "#c!d!b"
		flagcolor = "Blue"
		trueflagcolor = "Red"
		opteam = 3
		if _sctf_opt['flags'][flag]['team'] == 3:
			filter = "#t!d!b"
			flagcolor = "Red"
			trueflagcolor = "Blue"
			opteam = 2

		opteamString = "ctf_%i" % opteam
		if _sctf_opt['flags'][flag]['status'] == 0:
			es.server.cmd("est_nearcoord _sctf_temp %s 50 %s \"None\"" % (filter, _sctf_opt['flags'][flag]['defcoord']))
			userid = int(es.ServerVar("_sctf_temp"))
			if userid > 0:
				captureFlag(userid, flag)

			if not _sctf_opt['flags'][opteamString].has_key('defcoord'):
				continue
			if _sctf_opt['flags'][opteamString]['defcoord'] == "0 0 0":
				continue

			userid = int(_sctf_opt['flags'][opteamString]['owner'])
			if userid > 0:
				es.set("_sctf_temp", 0)
				es.server.cmd("est_nearcoord _sctf_temp %i 50 %s \"None\"" % (userid, _sctf_opt['flags'][flag]['defcoord']))
				
				if int(es.ServerVar("_sctf_temp")) == userid:
					#pteam = es.getplayerteam(userid)
					pname = es.getplayername(userid)
					psteamid = es.getplayersteamid(userid)
					
					es.centermsg("%s Team Score! (%s)" % (trueflagcolor, pname))
					es.msg("\x04SCTF:\x03 %s\x01 Team Score! (\x03%s\x01)" % (trueflagcolor, pname))
					#todo if (server_var(sctf_flag_score_add_kills_for_team) != 0) then es est_KillAdd #t server_var(sctf_flag_score_add_kills_for_team)
					#todo es_msg #multi #green SCTF:#default Red Team Wins#lightgreen server_var(sctf_flag_score_add_kills_for_team)#default Points For Flag Score!
					
					es.emitsound("player", userid, "weapons/explode3.wav" ,1.0, 0.5)
					es.emitsound("player", userid, "weapons/explode4.wav" ,1.0, 0.5)
					es.emitsound("player", userid, "weapons/explode5.wav" ,1.0, 0.5)
					
					if int(sctf_sacrifice_for_score) > 0:
						es.server.cmd("est_slay %i\nest_deathAdd %i -1" % (userid, userid))
					
					if int(sctf_score_for_score_flag) > 0:
						es.server.cmd("est_KillAdd %i %i" % (userid, int(sctf_score_for_score_flag)))
						es.tell(userid, "\x04SCTF:\x01 You win\x03 %i\x01 Kill(s) for\x03 Flag Score\x01!" % int(sctf_score_for_score_flag))
					
					flagScoreKey = trueflagcolor.lower()+"_score"
					_sctf_opt['game_options'][flagScoreKey] += 1
					
					resetFlags(opteamString)
					# todo es est_SetPlayerColor server_var(sctf_coord) 255 255 255 255

					es.event("initialize", "sctf_flag")
					es.event("setint", "sctf_flag", "userid", userid)
					es.event("setstring", "sctf_flag", "team", trueflagcolor.lower())
					es.event("setint", "sctf_flag", "rason", 2)
					es.event("setstring", "sctf_flag", "rason_sz", "score")
					es.event("fire", "sctf_flag")
					
					if _sctf_opt['game_options']['score_limit'] > 0 and _sctf_opt['game_options'][flagScoreKey] >= _sctf_opt['game_options']['score_limit']:
						endGame()
					else:
						scoreSound = _sctf_opt['game_sounds'][trueflagcolor.lower()+"_team_score"]
						if scoreSound is not None:
							myPlayerList = playerlib.getPlayerList()
							for fuserid in myPlayerList:
								es.playsound(fuserid.userid, scoreSound, 1.0)
							
					if int(sctf_stats) > 0:
						_sctf_stats.xexecute("UPDATE players SET flag_score = flag_score+1 WHERE steamid = '%s'" % psteamid)
					
	
		elif _sctf_opt['flags'][flag]['status'] == 2:
			if _sctf_opt['flags'][flag]['timedrop'] > -1:
				_sctf_opt['flags'][flag]['timedrop'] -= 1
							
			if _sctf_opt['flags'][flag]['timedrop'] == 0 or _sctf_opt['flags'][flag]['timedrop'] == -1:
				resetFlags(flag)
								
				es.centermsg("%s Flag returned! (Time)" % _sctf_opt['flags'][flag]['color'])
				es.msg("\x04SCTF:\x03 %s\x01 Flag\x01 returned! (\x03Time\x01)" % _sctf_opt['flags'][flag]['color'])
				
				soundToPlay = _sctf_opt['game_sounds'][_sctf_opt['flags'][flag]['color'].lower() + "_flag_return"]
				if soundToPlay is not None:
					myPlayerList = playerlib.getPlayerList()
					for userid in myPlayerList:
						es.playsound(userid.userid, soundToPlay, 1.0)
					
				es.event("initialize", "sctf_flag")
				es.event("setint", "sctf_flag", "userid", 0)
				es.event("setstring", "sctf_flag", "team", trueflagcolor.lower())
				es.event("setint", "sctf_flag", "rason", 4)
				es.event("setstring", "sctf_flag", "rason_sz", "return")
				es.event("fire", "sctf_flag")
			else:
				es.set("_sctf_temp", 0)
				es.server.cmd("est_nearcoord _sctf_temp #l!b 50 %s \"None \"" % _sctf_opt['flags'][flag]['currentcoord'])
				
				userid = int(es.ServerVar("_sctf_temp"))
				if userid > 0:
					pteam = es.getplayerteam(userid)
					pname = es.getplayername(userid)
					psteamid = es.getplayersteamid(userid)

					if int(pteam) == _sctf_opt['flags'][flag]['team']:
						resetFlags(flag)
						
						soundToPlay = _sctf_opt['game_sounds'][_sctf_opt['flags'][flag]['color'].lower()+"_flag_return"]
						if soundToPlay is not None:
							myPlayerList = playerlib.getPlayerList()
							for fuserid in myPlayerList:
								es.playsound(fuserid.userid, soundToPlay, 1.0)
						
						es.centermsg("%s Flag returned! (%s)" % (_sctf_opt['flags'][flag]['color'], pname))
						es.msg("\x04SCTF:\x03 %s\x01 Flag\x01 returned! (\x03%s\x01)" % (_sctf_opt['flags'][flag]['color'], pname))
						if int(sctf_score_for_return_flag) > 0:
							es.server.cmd("est_KillAdd %i %i" % (userid, int(sctf_score_for_return_flag))) 
							es.tell(userid, "\x04SCTF:\x01 You won\x03 %i\x01 Kill(s) for Flag Return" % int(sctf_score_for_return_flag))
							
						es.event("initialize", "sctf_flag")
						es.event("setint", "sctf_flag", "userid", userid)
						es.event("setstring", "sctf_flag", "team", trueflagcolor.lower())
						es.event("setint", "sctf_flag", "rason", 4)
						es.event("setstring", "sctf_flag", "rason_sz", "return")
						es.event("fire", "sctf_flag")

						if int(sctf_stats) > 0:
							_sctf_stats.xexecute("UPDATE players SET flag_return = flag_return+1 WHERE steamid = '%s'" % psteamid)
						
					else:
						captureFlag(userid, flag, True)

	if int(sctf_show_flag_status_hud):
		sctf_show_status_hud()
	#drawFlags()
	
def checkDrop():
	global _sctf_opt
	for flag in _sctf_opt['flags']:
		if not _sctf_opt['flags'][flag].has_key('defcoord'):
			continue
		if _sctf_opt['flags'][flag]['defcoord'] == "0 0 0":
			continue
			
		if _sctf_opt['flags'][flag]['status'] == 2:
			if _sctf_opt['flags'][flag]['timedrop'] > -1:
				_sctf_opt['flags'][flag]['timedrop'] -= 1

			if _sctf_opt['flags'][flag]['timedrop'] == 0 or _sctf_opt['flags'][flag]['timedrop'] == -1:
				resetFlags(flag)

				es.centermsg("%s Flag returned! (Time)" % _sctf_opt['flags'][flag]['color'])
				es.msg("\x04SCTF:\x03 %s\x01 Flag\x01 returned! (\x03Time\x01)" % _sctf_opt['flags'][flag]['color'])
					
				soundToPlay = _sctf_opt['game_sounds'][_sctf_opt['flags'][flag]['color'].lower() + "_flag_return"]
				if soundToPlay is not None:
					myPlayerList = playerlib.getPlayerList()
					for userid in myPlayerList:
						es.playsound(userid.userid, soundToPlay, 1.0)
						
				es.event("initialize", "sctf_flag")
				es.event("setint", "sctf_flag", "userid", 0)
				es.event("setstring", "sctf_flag", "team", _sctf_opt['flags'][flag]['color'].lower())
				es.event("setint", "sctf_flag", "rason", 4)
				es.event("setstring", "sctf_flag", "rason_sz", "return")
				es.event("fire", "sctf_flag")

def sctf_delayed_funcs(name, userid = 0):
	if int(userid) > 0:
		if not es.exists("userid", userid):
			return False
		
	if name == "repeat1s":
		if int(_sctf_opt['game_options']['game_time']) > 0:
			_sctf_opt['game_options']['game_time'] -= 1
			if _sctf_opt['game_options']['game_time'] == 0 or _sctf_opt['game_options']['game_time'] == -1:
				endGame()
				return True

		#checkFlags()
		checkDrop()
		if int(sctf_show_flag_status_hud) > 0:
			sctf_show_status_hud()
		gamethread.delayedname(1, "repeat1s", sctf_delayed_funcs, ("repeat1s"))
		return True
	if name == "clean":
		es.server.cmd("est_RemoveIdle weapon_;est_RemoveIdle item_;est_DeleteRagDolls")
		"""
		entlist = es.createentitylist()
		for index in entlist:
			if entlist[index]['classname'].startswith('weapon_') or entlist[index]['classname'].startswith('item_') or entlist[index]['classname'] == "cs_ragdoll":
				if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
					es.server.queuecmd('es_xremove %s' % index)
		"""
		gamethread.delayedname(_sctf_opt['game_options']['clean_idle'], "clean_idle", sctf_delayed_funcs, ("clean"))
		return True
	if name == "welcome":
		es.tell(userid, "\x04SCTF:\x03 Capture The Flag\x01 Mod\x01, version: \x03%s\n\x04SCTF:\x01 Written By:\x03 sn4k3\x01 AKA\x03 Tiago Conceicao\n\x04Visit:\x01 http://addons.eventscripts.com/addons/view/SCTF\n" % (sctf_version))
		return True
	if name == "autorespawn":
		if playerlib.getPlayer(userid).attributes['isdead']: # user is dead
			es.server.cmd("est_spawn %i" % int(userid))
		return True